# Tasks

This recipe creates a system for managing per-user tasks on your website.

As these are usually simple and not intended to be accessed directly on their
own, they have been configured as Storage Entities, so they won't clutter up the
Add Content menu, need to be excluded from any site search configuration, etc.

In addition to creating a bundle for managing tasks, it also provides a view
block for displaying them, and a page view to allow drag-and-drop sorting using
DraggableViews.

An optional [Tasks Extras](https://www.drupal.org/project/tasks_extras) add-on module is available to provide permissions-based
access for users to manage the tasks of others, and assign them. The module also
contains some formatting enhancements, for example to show a checkbox instead of
a text link for marking tasks as done. That module is optimized for the Olivero
theme, but may be compatible with other themes too.


## Table of contents

- Requirements
- Installation
- Configuration
- Maintainers


## Requirements

This recipe requires a number of modules to provide intuitive functionality:
Add Content by Bundle, Display Link Plus, DraggableViews, Storage, and Flag


## Installation

 * Install the Tasks recipe using the Project Browser (once it supports recipes)
   or on the command line, using composer to ensure all dependencies are brought
   in as well.
 * Then, run `php core/scripts/drupal recipe recipes/contrib/tasks` if
   installing on the command line.
 * There is also a Tasks Extras companion module that provides some formatting
   tweaks and also adds capabilities for users with the necessary permission to
   manage the tasks of other users.


## Configuration

 * Place the Tasks block wherever you want users to be able to create and manage
   their tasks. As part of the block configuration you can set the number of
   tasks to display.
 * For any role you want to give full use of the Tasks system, it should have
   the following permissions:
   * Access Draggableviews
   * Flag Status
   * Unflag Status
   * Add new Task Storage entities
   * Delete own Task Storage entities
   * Edit own Task Storage entities
   * View own unpublished Task Storage entities.
   * View published Task Storage entities.


## Maintainers

 * Martin Anderson-Clutz - [mandclu](https://www.drupal.org/u/mandclu)
